require('thor')
require('tty-table')

module Thengem
  class CLI < Thor
    default_task(:call)

    desc(:call, 'Calculate hours for timesheet entries')
    method_option(:gem_name, required: true, aliases: %i[-g])
    method_option(:date_string, required: false, aliases: %i[-d])
    method_option(:major_release, required: false, aliases: %i[-m])
    def call
      puts(table_formatter(gem_versions).render(:ascii))
    end

    private

    def table_formatter(versions)
      TTY::Table.new([options.fetch(:gem_name), 'released'], versions)
    end

    def gem_versions
      Thengem::GemVersions.call(
        gem_name: options.fetch(:gem_name),
        date_string: options.fetch(:date_string, nil),
        major_release: options.fetch(:major_release, nil),
      )
    end
  end
end
